Package org.spongepowered.asm.mixin.refmap

## Interface IReferenceMapper

- All Known Implementing Classes:
    `ReferenceMapper`, `RemappingReferenceMapper`

      public interface IReferenceMapper

  Interface for reference mapper objects

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getContext()` | Get the current context
    `java.lang.String` | `getResourceName()` | Get the resource name this refmap was loaded from (if available).
    `java.lang.String` | `getStatus()` | Get a user-readable "status" string for this refmap for use in error messages
    `boolean` | `isDefault()` | Get whether this mapper is defaulted.
    `java.lang.String` | `remap​(java.lang.String className, java.lang.String reference)` | Remap a reference for the specified owning class in the current context
    `java.lang.String` | `remapWithContext​(java.lang.String context, java.lang.String className, java.lang.String reference)` | Remap a reference for the specified owning class in the specified context
    `void` | `setContext​(java.lang.String context)` | Set the current remap context, can be null

- - ### Method Detail

    - #### isDefault

          boolean isDefault()

      Get whether this mapper is defaulted. Use this flag rather than reference comparison to `ReferenceMapper.DEFAULT_MAPPER` because of classloader shenanigans
      Returns:
        true if this mapper is a defaulted mapper

    - #### getResourceName

          java.lang.String getResourceName()

      Get the resource name this refmap was loaded from (if available).
      Returns:
        name of the resource

    - #### getStatus

          java.lang.String getStatus()

      Get a user-readable "status" string for this refmap for use in error messages
      Returns:
        status message

    - #### getContext

          java.lang.String getContext()

      Get the current context
      Returns:
        current context key, can be null

    - #### setContext

          void setContext​(java.lang.String context)

      Set the current remap context, can be null
      Parameters:
        `context` - remap context

    - #### remap

          java.lang.String remap​(java.lang.String className,
                                 java.lang.String reference)

      Remap a reference for the specified owning class in the current context
      Parameters:
        `className` - Owner class
        `reference` - Reference to remap
      Returns:
        remapped reference, returns original reference if not remapped

    - #### remapWithContext

          java.lang.String remapWithContext​(java.lang.String context,
                                            java.lang.String className,
                                            java.lang.String reference)

      Remap a reference for the specified owning class in the specified context
      Parameters:
        `context` - Remap context to use
        `className` - Owner class
        `reference` - Reference to remap
      Returns:
        remapped reference, returns original reference if not remapped